CD0J/POJ 851/3126 方老师与素数/Prime Path BFS

Prime Path

Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 9982   Accepted: 5724

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will
just have to paste four new digits over the four old ones on your office
door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a
path of prime numbers where only one digit is changed from one prime to
the next prime.

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don‘t know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on...
Help the prime minister to find the cheapest prime path between any two
given four-digit primes! The first digit must be nonzero, of course.
Here is a solution in the case above.

1033
1733
3733
3739
3779
8779
8179

The cost of this solution is 6 pounds. Note that the digit 1 which got
pasted over in step 2 can not be reused in the last step – a new 1 must
be purchased.

Input

One line with a positive number: the number of test cases (at most 100).
Then for each test case, one line with two numbers separated by a
blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0
#include <cstdio>
#include <cmath>
#include <cstring>
#include <ctime>
#include <iostream>
#include <algorithm>
#include <set>
#include <vector>
#include <sstream>
#include <queue>
#include <typeinfo>
#include <fstream>
typedef long long ll;
using namespace std;
//freopen("D.in","r",stdin);
//freopen("D.out","w",stdout);
#define sspeed ios_base::sync_with_stdio(0);cin.tie(0)
#define maxn 100001
const int inf=0x7fffffff;   //无限大
const int MAXN = 10000;
bool flag[MAXN];
int primes[MAXN], pi;
struct point
{
    int x;
    int y;
};
void GetPrime_1()
{
    int i, j;
    pi = 0;
    memset(flag, false, sizeof(flag));
    for (i = 2; i < MAXN; i++)
        if (!flag[i])
        {
            primes[i] = 1;//素数标识为1
            for (j = i; j < MAXN; j += i)
                flag[j] = true;
        }
}
int vis[maxn];
int main()
{
    GetPrime_1();
    int t;
    cin>>t;
    while(t--)
    {
        memset(vis,0,sizeof(vis));
        int n,m;
        cin>>n>>m;
        vis[n]=1;
        queue<point> q;
        q.push((point){n,0});
        int flag1=0;
        while(!q.empty())
        {
            point now=q.front();
            if(now.x==m)
            {
                flag1=now.y;
                break;
            }
            point next;
            for(int i=0;i<=9;i++)
            {
                next.x=now.x/10;
                next.x*=10;
                next.x+=i;
                next.y=now.y+1;
                if(next.x<1000||next.x>=10000)
                    continue;
                if(vis[next.x]==1)
                    continue;
                if(next.x==m)
                {
                    flag1=next.y;
                    break;
                }
                if(primes[next.x]==1)
                {
                    //cout<<next.x<<endl;
                    vis[next.x]=1;
                    q.push(next);
                }

            }
            for(int i=0;i<=9;i++)
            {
                int temp=now.x%10;
                next.x=now.x/100;
                next.x*=100;
                next.x+=i*10;
                next.x+=temp;
                if(next.x<1000||next.x>=10000)
                    continue;
                if(vis[next.x]==1)
                    continue;
                if(next.x==m)
                {
                    flag1=next.y;
                    break;
                }
                if(primes[next.x]==1)
                {
                    //cout<<next.x<<endl;
                    vis[next.x]=1;
                    q.push((point){next.x,now.y+1});
                }
            }
            for(int i=0;i<=9;i++)
            {
                int temp=now.x%100;
                next.x=now.x/1000;
                next.x*=1000;
                next.x+=i*100;
                next.x+=temp;
                if(next.x<1000||next.x>=10000)
                    continue;
                if(vis[next.x]==1)
                    continue;
                if(next.x==m)
                {
                    flag1=next.y;
                    break;
                }
                if(primes[next.x]==1)
                {
                    //cout<<next.x<<endl;
                    vis[next.x]=1;
                    q.push((point){next.x,now.y+1});
                }
            }
            for(int i=0;i<=9;i++)
            {
                int temp=now.x%1000;
                next.x=now.x/10000;
                next.x*=10000;
                next.x+=i*1000;
                next.x+=temp;
                if(next.x<1000||next.x>=10000)
                    continue;
                if(vis[next.x]==1)
                    continue;
                if(next.x==m)
                {
                    flag1=next.y;
                    break;
                }
                if(primes[next.x]==1)
                {
                //    cout<<next.x<<endl;
                    vis[next.x]=1;
                    q.push((point){next.x,now.y+1});
                }
            }
            if(flag1>0)
            break;
            q.pop();
        }
    printf("%d\n",flag1);
    }
    return 0;
}
时间: 2024-10-12 23:22:14

CD0J/POJ 851/3126 方老师与素数/Prime Path BFS的相关文章

cdoj 851 方老师与素数 bfs

方老师与素数 Time Limit: 3000/1000MS (Java/Others)     Memory Limit: 65535/65535KB (Java/Others) Submit Status 方老师最近很喜欢素数,他想玩一个游戏: 现在有两个44位的素数nn和mm,你一次可以改变nn的一位数字,并且改变过后的新数字必须也是个素数,并且也不能有前导00.请问使nn变为mm最少需要多少步. 例如n=1033n=1033 m=8179m=8179 那么可行的变化是: 1033 173

poj 3126 Prime Path (bfs)

Prime Path Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 13813   Accepted: 7796 Description The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-dig

POJ 3126 Prime Path(BFS 数字处理)

题意  给你两个4位素数a, b  你每次可以改变a的一位数但要求改变后仍为素数  求a至少改变多少次才能变成b 基础的bfs  注意数的处理就行了  出队一个数  然后入队所有可以由这个素数经过一次改变而来的素数  知道得到b #include <cstdio> #include <cstring> using namespace std; const int N = 10000; int p[N], v[N], d[N], q[N], a, b; void initPrime(

[POJ]P3126 Prime Path[BFS]

[POJ]P3126 Prime Path Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 35230   Accepted: 18966 Description The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change

POJ 3126 Prime Path (BFS + 素数筛)

链接 : Here! 思路 : 素数表 + BFS, 对于每个数字来说, 有四个替换位置, 每个替换位置有10种方案(对于最高位只有9种), 因此直接用 BFS 搜索目标状态即可. 搜索的空间也不大... /************************************************************************* > File Name: E.cpp > Author: > Mail: > Created Time: 2017年11月26日

POJ 3126 Prime Path bfs 简单

给出2个四位数的素数a,b,要求a每次变化只可以变a的4个数字的其中一个,并且变化后的数也要是素数,问a至少要变化多少次才可以变为b. 注意,a的千位数不能变化为0 先打出素数表,再bfs数a即可. 1 #include<cstdio> 2 #include<cstring> 3 #include<queue> 4 5 using namespace std; 6 7 const int maxn=10010; 8 const int inf=0x3f3f3f3f; 9

POJ 3126 Prime Path (BFS+剪枝)

题目链接:传送门 题意: 给定两个四位数a,b,每次可以改变a的任意一位,并且确保改变后的a是一个素数. 问最少经过多少次改变a可以变成b. 分析: BFS,每次枚举改变的数,有一个剪枝,就是如果这个改变的数之前已经得到过了, 就没有必要继续变回它了. 代码如下: #include <iostream> #include <cstring> #include <algorithm> #include <cstdio> #include <queue&g

POJ 3126 Prime Path(素数路径)

p.MsoNormal { margin-bottom: 10.0000pt; font-family: Tahoma; font-size: 11.0000pt } h1 { margin-top: 5.0000pt; margin-bottom: 5.0000pt; text-align: left; font-family: 宋体; font-weight: bold; font-size: 24.0000pt } span.10 { font-family: "Times New Rom

F - Prime Path POJ 3126 筛选素数+bfs

F - Prime Path Time Limit:1000MS Memory Limit:65536KB 64bit IO Format:%I64d & %I64u Submit Status Practice POJ 3126 Description The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have t